<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\Sm00004005ParamFaturaContratoService;

class Sm00004005ParamFaturaContratoController extends SMCrud {
    
    protected $dataSourceName = 'fct_paramfatcont_widget';
    protected $ServiceParamFaturaContrato;
    
    public function __construct($crudService, $environment, Sm00004005ParamFaturaContratoService $ServiceParamFaturaContrato) {
        parent::__construct($crudService, $environment);
        $this->ServiceParamFaturaContrato  = $ServiceParamFaturaContrato;
    }
    
    /**
     * A função "insereDadosContrato" insere os dados de parametização 
     * de fatiuramento na tabela de Contrato (FCT_CONTRATO).
     */
    public function insereDadosContrato(Request\Row $request, Response $response) {
    
        $row = $request->getRow();
        
        
        $idFaturaContr         = $row['IDFATURACONTR']; 
        $cdModPgto             = $row['CDMODPGTO'];
        $qtParcelasFatu        = $row['QTPARCELASFATU'];
        $nrDiaVencParcelasFatu = $row['NRDIAVENCPARCELASFATU'];
        $dtInicFatContr        = $row['DTINICFATCONTR'];
        $idQtDiasCompCon       = $row['IDQTDIASCOMPCON'];
        $nrQtDiasCompCon       = $row['NRQTDIASCOMPCON'];
        $idCompetCont          = $row['IDTPCOMPETCONT'];
        $nrDiaCompetCont       = $row['NRDIACOMPETCONT'];
        $idTpDtEmissNf         = $row['IDTPDTEMISSNF'];
        $nrDiaDtEmissNf        = $row['NRDIADTEMISSNF'];
        $idTpDtVenc            = $row['IDTPDTVENC'];
        $nrDiaVenParcFat       = $row['NRDIAVENPARCFAT'];
        $idTpFatuIncomp        = $row['IDTPFATUINCOMP'];
        $seqContrato           = $row['NRSEQCONTRATO'];
        
        $InsereDadosContr = $this->ServiceParamFaturaContrato->insereDadosContrato($idFaturaContr, $cdModPgto, $qtParcelasFatu, $nrDiaVencParcelasFatu, $dtInicFatContr, $idQtDiasCompCon, $nrQtDiasCompCon, $idCompetCont, $nrDiaCompetCont, $idTpDtEmissNf, $nrDiaDtEmissNf, $idTpDtVenc, $nrDiaVenParcFat, $idTpFatuIncomp, $seqContrato);
    }  
    
    
    public function getDadosModeloContrato(Request\Row $request, Response $response){
        try{
            $row = $request->getRow();
            
            
            $nrseqmodcontra = $row["NRSEQMODCONTRA"];
            $nrorg      = $row["NRORG"];
            $param = $this->ServiceParamFaturaContrato->getDadosModeloContrato($nrseqmodcontra, $nrorg);
            $response->addDataSet(new DataSet("MODELO", $param));
        } catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
   
}
?>